package com.zhongzheng.modules.grade.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.grade.bo.StudyCountLogAddBo;
import com.zhongzheng.modules.grade.bo.StudyCountLogEditBo;
import com.zhongzheng.modules.grade.bo.StudyCountLogQueryBo;
import com.zhongzheng.modules.grade.domain.StudyCountLog;
import com.zhongzheng.modules.grade.mapper.StudyCountLogMapper;
import com.zhongzheng.modules.grade.service.IStudyCountLogService;
import com.zhongzheng.modules.grade.vo.StudyCountLogVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 学习次数使用记录Service业务层处理
 *
 * @author hjl
 * @date 2022-01-20
 */
@Service
public class StudyCountLogServiceImpl extends ServiceImpl<StudyCountLogMapper, StudyCountLog> implements IStudyCountLogService {

    @Override
    public StudyCountLogVo queryById(Long id){
        StudyCountLog db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, StudyCountLogVo.class);
    }

    @Override
    public List<StudyCountLogVo> queryList(StudyCountLogQueryBo bo) {
        LambdaQueryWrapper<StudyCountLog> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getUserId() != null, StudyCountLog::getUserId, bo.getUserId());
        lqw.eq(bo.getGradeId() != null, StudyCountLog::getGradeId, bo.getGradeId());
        lqw.eq(bo.getOrderGoodsId() != null, StudyCountLog::getOrderGoodsId, bo.getOrderGoodsId());
        lqw.eq(bo.getStudyCount() != null, StudyCountLog::getStudyCount, bo.getStudyCount());
        lqw.eq(bo.getStatus() != null, StudyCountLog::getStatus, bo.getStatus());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<StudyCountLogVo> entity2Vo(Collection<StudyCountLog> collection) {
        List<StudyCountLogVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, StudyCountLogVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<StudyCountLog> page = (Page<StudyCountLog>)collection;
            Page<StudyCountLogVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(StudyCountLogAddBo bo) {
        StudyCountLog add = BeanUtil.toBean(bo, StudyCountLog.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(StudyCountLogEditBo bo) {
        StudyCountLog update = BeanUtil.toBean(bo, StudyCountLog.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(StudyCountLog entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
